#!/usr/bin/env node

const fs = require('fs');
const figlet = require('figlet');
const chalk = require('chalk');
const program = require('commander');
const generate = require('../scripts/generate');
const path = require('path');

const [,, ...args] = process.argv;

(() => {

  // ! TODO: Change name to match package name
  // ! FIXME: CHANGE TO ROOT WHEN BUILDING PACKAGE
  const rootPath = path.join(__dirname, `../../node_modules`, `create-stencil-component`);
  const devRootPath = path.join(__dirname, `../node_modules`, `chalk`);
  let isStencilProject = false;

  program
    .version(`1.0.0-beta0`, `-v, --version, version, v`, `output the current version`)
    .description(`A CLI for creating stencil components`)
    .option(`g, generate`, `Generate an [item] with [name]. Example: st g c my-component`)
    .arguments(`<item> <name>`)
    .action((item, name) => {
      itemType = item || null;
      itemName = name || null;
    });

  program.parse(process.argv);

  // fs.stat(rootPath, (err, stats) => {
  //   if (err) {
  //     console.log(
  //       chalk.red.underline.bold(`
  //        _____________________________________________________
  //       |                                                     |
  //       |  Components MUST generated inside of a Stencil      |
  //       |  project                                            |
  //       |_____________________________________________________|
  //       `)
  //     );
  //     console.error(err);
  //     process.exit(1);
  //   };
  //   if (stats.isDirectory()) {
  //     // allow the project to scaffold
  //     isStencilProject = true;
  //   }
  // });
  if (program.generate) {
    generate(itemType, itemName);
  }

})();
